	;voir class_masm Allocation dynamique de mmoire (inclus)

	
Comment 
**** Pour creer un tampon en mmoire heap,utilisable comme un tampon en data
	.data
        tampon BLOCHEAP <>
	.code
	invoke CreateHeapBuffer,addr tampon,1024   ;1024 taille du tampon
	;retourne avec eax pheap (pointeur tampon) ,ecx taille mem
	invoke FreeHeapBuffer,addr tampon
**** Un bloc cumulatif ou toutes les donnes sont ajoutes les unes aprs les autres
     la fonction gre les acroissements de taille
	.data
        buffer BLOCHEAP <>
	.code
	invoke WriteToBlocHeap,addr buffer,addr variable,taille variable ou NULL
	;Si taille = 0,variable doit se terminer par un zero
	invoke WriteToBlocHeap,addr buffer,NULL,NULL ;libre le buffer

**** Un tableau de variables accessibles par leurs numeros d'entre de 1  N	
	.data
        tableau TABLEAU <>
	.code
	invoke AddElement,addr tableau,addr variable,taille variable ou NULL
	;Si taille = 0,variable doit se terminer par un zero
	invoke GetElement,addr tableau,nN  ;nN indice de 1  N de l'lment
	;retourne l'adresse de l'lment
	;On doit toujours accder  l'lment de cette manire
	;les blocs heap changent d'adresses en fonction des besoins du systme
	invoke FreeTableau,addr tableau ;libre le tableau	






.const
	BLOCHEAP STRUCT
		Hheap 		dd ?	;Handle heap,GetProcessHeap
		Pheap 		dd ?	;Pointeur heap,HeapAlloc,Heapfree
		TailleData 		dd ?	;size of data and offset of next element
		TailleBloc 		dd ?  ;size of allocated mem
		AllocBy 		dd ?  ;size to increase the size of mem by,optimize
	BLOCHEAP ENDS
	WriteToBlocHeap 		PROTO  :DWORD,  :DWORD,  :DWORD 
	CreateHeapBuffer 		PROTO  :DWORD,  :DWORD 
	FreeHeapBuffer 		PROTO  :DWORD 
	;element tableau
	AddElement 			PROTO  :DWORD,  :DWORD,  :DWORD 
	GetElement 			PROTO  :DWORD,  :DWORD 
	FreeTableau 		PROTO  :DWORD 


	DefautAllocatedMem equ 400h	;1024 bytes		
	TABLEAU STRUCT
		indice 	BLOCHEAP <0,0,0,0,16>		;increase the mem only by 16
		data   	BLOCHEAP <0,0,0,0,400h>       ;increase mem by 1024
		NbElements	dd 0					;Number of elements in the array
		MaxSize	dd 0					;size of the bigger element
	TABLEAU ENDS
	ELEMENT STRUCT
		aOffset dd ?
		taille dd ?
	ELEMENT ENDS

.code
;create a heap buffer to be write and rewrite as a normal buffer in data
;His adress don't change (if you don't reallocate it)
;Arguments
;pointer on a BLOCHEAP structure,size of desired mem
;size of needed memory is rounded at the upper 16 bytes
;return 0 failed,else eax pointer on heap,ecx size of allocated mem,BLOCHEAP filled
;################################################################
CreateHeapBuffer PROC uses esi pblocheap:DWORD, taille:DWORD 
			Local  retour:DWORD
      mov retour,0	;failed by defaut
	.if pblocheap == 0 || taille == 0
		jmp FindeCreateHeapBuffer
	.endif
	mov esi,pblocheap
	.if dword ptr [esi][BLOCHEAP.Hheap] == 0	;pas de handle,le crer
		invoke GetProcessHeap
		mov   dword ptr [esi][BLOCHEAP.Hheap],eax
		.if eax == NULL
			;invoke RetrouveMessageErreur,addr erreurBlochandleheap
			jmp FindeCreateHeapBuffer
		.endif
	.endif
	;don't realloc
	.if dword ptr [esi][BLOCHEAP.Pheap]	!= 0
		jmp FindeCreateHeapBuffer
	.endif
	mov ecx,taille
	add ecx,16
	and ecx,0FFFFFFF0h  ;optimize heap memory (move block faster,less hole)	
	mov retour,ecx
	invoke HeapAlloc,dword ptr [esi][BLOCHEAP.Hheap],HEAP_ZERO_MEMORY,ecx
	.if eax == 0
		mov retour,0
		;invoke RetrouveMessageErreur,addr erreurBlocPointeheap
		jmp FindeCreateHeapBuffer			
	.endif		
	;sauvegarder le pointeur heap
	mov dword ptr [esi][BLOCHEAP.Pheap],eax
	mov ecx,retour
	mov retour,eax
	mov dword ptr [esi][BLOCHEAP.TailleBloc],ecx
	;retourne avec eax pheap ,ecx taille mem
 FindeCreateHeapBuffer:
         mov eax,retour
         ret
CreateHeapBuffer endp

;################################################################
 ;enter adresse of BLOCHEAP
;return 1 success,0 failed
FreeHeapBuffer PROC uses esi pblocheap:DWORD 
			Local  retour:DWORD
         mov retour,1
	mov esi,pblocheap
	.if dword ptr [esi][BLOCHEAP.Pheap]	== 0 || dword ptr [esi][BLOCHEAP.Hheap] == 0
		mov retour,0
		jmp FindeFreeHeapBuffer
	.endif
	invoke HeapFree,[esi][BLOCHEAP.Hheap],NULL,[esi][BLOCHEAP.Pheap]
	mov retour,eax
	.if eax != 0		
		mov eax,0
		mov [esi][BLOCHEAP.Pheap],eax
		mov [esi][BLOCHEAP.TailleBloc],eax
	.endif
	
 FindeFreeHeapBuffer:
         mov eax,retour
         ret
FreeHeapBuffer endp

;################################################################

;used to make a single block of several data
;the data couldn't be retrieve by indice
;Arguments
;adresse of a BLOCHEAP structure,if BLOCHEAP.AllocBy == 0 ,incrment mem by 400h
;adresse of the data to write in heap memory
;Taille,size of data to write in heap memory.If zero,supposed to be a zero terminated data

;################################################################
WriteToBlocHeap PROC uses esi edi ebx pblocheap:DWORD,  pData:DWORD,  Taille:DWORD 
			Local   longueur:DWORD,sizemem
			LOCAL   PointeurEcriture:DWORD
			Local  retour:DWORD
	mov esi,pblocheap	
	;------------ vrifier la validit des arguments ---------------
	;-----pData NULL ,Taille== NULL librer le tampon
	.if pData == 0 && Taille == 0
		.if dword ptr [esi][BLOCHEAP.Pheap] != 0
			invoke HeapFree,dword ptr [esi][BLOCHEAP.Hheap],NULL,dword ptr [esi][BLOCHEAP.Pheap]
			.if eax == NULL
				;invoke RetrouveMessageErreur,addr erreurBlocHeapFree
				mov retour,0
				jmp FindeWriteToBlocHeap
			.endif		
			xor eax,eax
			mov dword ptr [esi][BLOCHEAP.Pheap],eax
			mov dword ptr [esi][BLOCHEAP.TailleData],eax
			mov dword ptr [esi][BLOCHEAP.TailleBloc],eax
			mov retour,1
		.else
			mov retour,0
		.endif
		jmp FindeWriteToBlocHeap
	.endif
	;---- taille de la chaine a crire,si NULL ,rechercher sa longueur
	.if Taille == 0
		invoke lstrlen,pData
		mov longueur,eax
		.if eax == 0
			mov retour,0
			jmp FindeWriteToBlocHeap	;rien  crire
		.endif
	.else
		Push Taille
		Pop longueur
	.endif
	;---- handle heap ----------------------------------------------------
	.if dword ptr [esi][BLOCHEAP.Hheap] == 0	;pas de handle,le crer
		invoke GetProcessHeap
		mov   dword ptr [esi][BLOCHEAP.Hheap],eax
		.if eax == NULL
			;invoke RetrouveMessageErreur,addr erreurBlochandleheap
			mov retour,0
			jmp FindeWriteToBlocHeap
		.endif
	.endif
	;vrifier l'incrment
	.if dword ptr [esi].BLOCHEAP.AllocBy == 0
		mov [esi].BLOCHEAP.AllocBy,DefautAllocatedMem
	.endif	
	;---- pointeur heap first writing -------------------
	.if dword ptr [esi][BLOCHEAP.Pheap] == 0
		mov edx,longueur
		inc edx	;pour le zero de fin de bloc data
		mov ecx,[esi].BLOCHEAP.AllocBy
		@@:
		.if ecx < edx
			add ecx,[esi].BLOCHEAP.AllocBy
			jmp @B
		.endif
		mov sizemem,ecx
		invoke HeapAlloc,dword ptr [esi][BLOCHEAP.Hheap],HEAP_ZERO_MEMORY,ecx
		.if eax == 0
			;invoke RetrouveMessageErreur,addr erreurBlocPointeheap
			mov retour,0
			jmp FindeWriteToBlocHeap			
		.endif
		;sauvegarder le pointeur heap
		mov dword ptr [esi][BLOCHEAP.Pheap],eax		
		;sauvegarder la taille de la mmoire alloue
		Push sizemem
		Pop [esi].BLOCHEAP.TailleBloc
		;sauvegarder la taille de la data 
		mov eax,longueur
		mov dword ptr [esi][BLOCHEAP.TailleData],eax
		;crire la data
		mov ecx,longueur
		mov edi,dword ptr [esi][BLOCHEAP.Pheap]
		mov esi,pData
		cld
		rep movsb
		mov retour,1
		jmp FindeWriteToBlocHeap
		
	.endif
	;tout est valide et une premiere opration d'criture  dja t faite
	;la longueur  crire est dfinie
	mov edx,dword ptr [esi][BLOCHEAP.TailleData]
	mov eax,longueur
	add edx,eax
	inc edx		;totale des donnes + le zero
	mov ecx,dword ptr [esi].BLOCHEAP.TailleBloc
	.if edx > ecx
		@@:
		add ecx,dword ptr [esi].BLOCHEAP.TailleBloc
		.if edx > ecx
			jmp @B
		.endif
		mov sizemem,ecx
		invoke HeapReAlloc,dword ptr [esi][BLOCHEAP.Hheap],HEAP_ZERO_MEMORY,\
					dword ptr [esi][BLOCHEAP.Pheap],sizemem
		.if eax == 0
			;invoke RetrouveMessageErreur,addr erreurBlocHeapReAlloc
			mov retour,0
			jmp FindeWriteToBlocHeap
		.else
			;l'ventuel nouveau pointeur
			mov dword ptr [esi][BLOCHEAP.Pheap],eax
		
			;sauvegarder la nouvelle taille de la mmoire alloue
			Push sizemem
			Pop [esi].BLOCHEAP.TailleBloc
						
		.endif		
	.endif	
	;la taille mmoire est suffisante	
	;la nouvelle taille data
	mov edx,dword ptr [esi][BLOCHEAP.TailleData]
	mov PointeurEcriture,edx			;le dcalage  l'criture
	mov eax,longueur
	add edx,eax
	;inc edx		;totale des donnes sans le zero	
	mov dword ptr [esi][BLOCHEAP.TailleData],edx
	;recopier les donnes
	mov edi,dword ptr [esi][BLOCHEAP.Pheap]
	add edi,PointeurEcriture
	mov ecx,longueur
	mov esi,pData
	cld
	rep movsb	
       mov retour,1
 FindeWriteToBlocHeap:
       mov eax,retour
         ret
WriteToBlocHeap endp		

;add an element to an array of elements
;each element can be retrieve by there number 1 to .. with GetElement
;Arguments
;adresse of a TABLEAU structure ,each BLOCHEAP of this structure can fix a AllocBy
;adresse of the data to write in heap memory
;Taille,size of data to write in heap memory.If zero,supposed to be a zero terminated data
;################################################################
AddElement PROC uses esi ptableau:DWORD,  pData:DWORD,  Taille:DWORD 
			Local nombre:DWORD
			local element:ELEMENT
			Local  retour:DWORD
         mov retour,0
	.if ptableau == 0 || pData == 0
		jmp FindeAddElement
	.endif
	.if Taille == 0
		invoke lstrlen, pData
		mov Taille,eax
	.endif
	mov esi,ptableau
	mov eax,[esi].TABLEAU.NbElements
	mov eax,[esi].TABLEAU.data.TailleData
	mov element.aOffset,eax
	push Taille
	pop  element.taille
	
	lea esi,[esi].TABLEAU.data
	invoke WriteToBlocHeap,esi,pData,Taille
	.if eax != 0
		;write the ref of the element
		mov esi,ptableau
		lea esi,[esi].TABLEAU.indice
		invoke WriteToBlocHeap,esi,addr element,sizeof ELEMENT
		mov retour,eax
		.if eax != 0
			mov esi,ptableau
			inc dword ptr [esi].TABLEAU.NbElements
			mov eax,Taille
			.if eax > dword ptr [esi].TABLEAU.MaxSize
				mov [esi].TABLEAU.MaxSize,eax
			.endif
		.endif
	.endif
	
	
 FindeAddElement:
         mov eax,retour
         ret
AddElement endp

;################################################################
;tableau base 1 to N
;return the adress of an element N in eax,ecx size
;adresse of a TABLEAU structure 
;numero indice of the variable,1 to N
GetElement PROC uses esi ptableau:DWORD,  numero:DWORD 
			Local  retour:DWORD
      mov retour,0
	mov esi,ptableau
	mov eax,[esi].TABLEAU.NbElements
	.if eax < numero
		jmp FindeGetElement
	.endif
	;get the pointer on the indices of elements
	mov eax,numero
	dec eax
	mov edx,0
	mov ecx,sizeof ELEMENT
	mul ecx	;eax offset indice
	mov edx,[esi].TABLEAU.indice.Pheap
	add edx,eax		;Pheap + offset = adresse d'un lment
	mov eax,[edx].ELEMENT.aOffset
	mov ecx,[edx].ELEMENT.taille
	mov edx,[esi].TABLEAU.data.Pheap
	add edx,eax
	mov retour,edx
	;retour eax adresse,ecx taille
	
 FindeGetElement:
         mov eax,retour
         ret
GetElement endp

;################################################################
;adresse of a TABLEAU structure 
FreeTableau PROC uses esi ptableau:DWORD 
			Local  Hheap:DWORD
			Local  retour:DWORD
      mov retour,1
	mov esi,ptableau
	.if [esi].TABLEAU.data.Hheap != 0 && [esi].TABLEAU.data.Pheap != 0
		invoke HeapFree,[esi].TABLEAU.data.Hheap,NULL,[esi].TABLEAU.data.Pheap
		.if eax != 0
			mov eax,0
			mov [esi].TABLEAU.data.Pheap,eax
			mov [esi].TABLEAU.data.TailleData,eax
			mov [esi].TABLEAU.data.TailleBloc,eax  ; ready for another use
		.endif		
	.endif
	.if [esi].TABLEAU.indice.Hheap != 0 && [esi].TABLEAU.indice.Pheap != 0
		invoke HeapFree,[esi].TABLEAU.indice.Hheap,NULL,[esi].TABLEAU.indice.Pheap
		.if eax != 0
			mov eax,0
			mov [esi].TABLEAU.indice.Pheap,eax
			mov [esi].TABLEAU.indice.TailleData,eax
			mov [esi].TABLEAU.indice.TailleBloc,eax  ; ready for another use
			mov [esi].TABLEAU.NbElements,eax
			mov [esi].TABLEAU.MaxSize,eax
		.endif						
	.endif	
 FindeFreeTableau:
         mov eax,retour
         ret
FreeTableau endp

;################################################################


.const


